#include <stdio.h>
#include <iostream.h>
#include <math.h>

class TSummator{
	int n;
public:
	double* Koef;
	TSummator();
	TSummator(int);
	TSummator(int, double*);
	~TSummator();
	void Init(int);

	double Calc(double*);
	void Assign(double*);
	void Learn(int size, double*);
	void Change(double*, double);
	void KoefShow();
};

TSummator::TSummator(){
	n = 0;
};

void TSummator::Init(int Count){
	Koef = new double[Count-1];
	for (int i=0; i<Count; Koef[i] = 0.25, i++);
	n = Count;
};

TSummator::TSummator(int Count){
	Koef = new double[Count-1];
	for (int i=0; i<Count; Koef[i] = 0.25, i++);
	n = Count;
};

TSummator::TSummator(int Count, double* Values){
	Koef = new double[Count-1];
	n = Count;
	for (int i=0; i<Count; i++, Koef[i] = Values[i]);
};

TSummator::~TSummator(){
	delete[] Koef;
};

double TSummator::Calc(double* Values){
	double s = 0;
  int i;
	for (i=0, s=0; i<n; i++){
    s+=Koef[i]*Values[i];
  };
	return s;
};

void TSummator::Assign(double* Values){
	for (int i=0; i<n; i++) {Koef[i] = Values[i];};
};

void TSummator::Learn(int Size, double* Values){
	while (Calc(Values)<=0) {
		for (int i=0; i<n; i++) {Koef[i] += Values[i]/Size;};
	};
};

void TSummator::Change(double *A, double Alpha){
	for (int i = 0; i < n; i++)
		Koef[i] += A[i]*Alpha;
};

void TSummator::KoefShow(){
	for (int i=0; i<n; i++) {cout<<Koef[i]<<"; ";};
	cout<<"\n";
};

class TNeyron: public TSummator{
public:
	double Calc(double*);
};

double TNeyron::Calc(double *A){
	return 1/(1+exp(TSummator::Calc(A)));
};

double Learn1[5][3]={{0.5, 10, 1}, {6, 5, 1}, {2, 1, 1}, {4, 2, 1}, {1, 1, 1}};
double Learn2[5][3]={{-0.5, 10, 1}, {-6, 5, 1}, {-2, 1, 1}, {-4, 2, 1}, {-1, 1, 1}};

class TAdaline{
private:
	TSummator *S;
public:
	int OutputCount, InputCount;
	TAdaline(int, int);
	~TAdaline();
	void Learn();
	void Check(double *);
};

TAdaline::TAdaline(int c1, int c2){
	OutputCount = c1;
	InputCount = c2;
	S = new TSummator[c1-1];
	for (int i=0; i<c1; S[i].Init(c2), i++);
};

TAdaline::~TAdaline(){
	delete[] S;
};

double Numbers[10][64]={
			{0, 0, 1, 1, 1, 1, 0, 0,//0
			       0, 1, 0, 0, 0, 0, 1, 0,
			       0, 1, 0, 0, 0, 0, 1, 0,
			       0, 1, 0, 0, 0, 0, 1, 0,
			       0, 1, 0, 0, 0, 0, 1, 0,
			       0, 1, 0, 0, 0, 0, 1, 0,
			       0, 1, 0, 0, 0, 0, 1, 0,
			       0, 0, 1, 1, 1, 1, 0, 0},

			{0, 0, 0, 0, 0, 1, 1, 0,//1
			       0, 0, 0, 0, 1, 0, 1, 0,
			       0, 0, 0, 1, 0, 0, 1, 0,
			       0, 0, 0, 0, 0, 0, 1, 0,
			       0, 0, 0, 0, 0, 0, 1, 0,
			       0, 0, 0, 0, 0, 0, 1, 0,
			       0, 0, 0, 0, 0, 0, 1, 0,
			       0, 0, 0, 0, 0, 0, 1, 0},

			{0, 0, 1, 1, 1, 1, 0, 0,//2
			       0, 1, 0, 0, 0, 0, 1, 0,
			       0, 0, 0, 0, 0, 0, 1, 0,
			       0, 0, 0, 0, 0, 0, 1, 0,
			       0, 0, 0, 0, 1, 1, 0, 0,
			       0, 0, 1, 1, 0, 0, 0, 0,
			       0, 1, 0, 0, 0, 0, 0, 0,
			       0, 1, 1, 1, 1, 1, 1, 0},

			{0, 0, 1, 1, 1, 1, 0, 0,//3
			       0, 1, 0, 0, 0, 0, 1, 0,
			       0, 0, 0, 0, 0, 0, 1, 0,
			       0, 0, 0, 0, 1, 1, 0, 0,
			       0, 0, 0, 0, 0, 0, 1, 0,
			       0, 0, 0, 0, 0, 0, 1, 0,
			       0, 1, 0, 0, 0, 0, 1, 0,
			       0, 0, 1, 1, 1, 1, 0, 0},

			{0, 0, 0, 1, 0, 0, 1, 0,//4
			       0, 0, 1, 0, 0, 0, 1, 0,
			       0, 1, 0, 0, 0, 0, 1, 0,
			       0, 1, 0, 0, 0, 0, 1, 0,
			       0, 1, 1, 1, 1, 1, 1, 0,
			       0, 0, 0, 0, 0, 0, 1, 0,
			       0, 0, 0, 0, 0, 0, 1, 0,
			       0, 0, 0, 0, 0, 0, 1, 0},

			{0, 1, 1, 1, 1, 1, 1, 0,//5
						 0, 1, 0, 0, 0, 0, 0, 0,
						 0, 1, 0, 0, 0, 0, 0, 0,
						 0, 1, 1, 1, 1, 1, 0, 0,
						 0, 0, 0, 0, 0, 0, 1, 0,
						 0, 0, 0, 0, 0, 0, 1, 0,
						 0, 1, 0, 0, 0, 0, 1, 0,
						 0, 0, 1, 1, 1, 1, 0, 0},

			{0, 0, 1, 1, 1, 1, 0, 0,//6
						 0, 1, 0, 0, 0, 0, 1, 0,
						 0, 1, 0, 0, 0, 0, 0, 0,
						 0, 1, 0, 1, 1, 0, 0, 0,
						 0, 1, 1, 0, 0, 1, 0, 0,
						 0, 1, 0, 0, 0, 0, 1, 0,
						 0, 1, 0, 0, 0, 0, 1, 0,
						 0, 0, 1, 1, 1, 1, 0, 0},

			{0, 1, 1, 1, 1, 1, 1, 0,//7
						 0, 0, 0, 0, 0, 0, 1, 0,
						 0, 0, 0, 0, 0, 0, 1, 0,
						 0, 0, 0, 0, 0, 1, 0, 0,
						 0, 0, 0, 0, 0, 1, 0, 0,
						 0, 0, 0, 0, 1, 0, 0, 0,
						 0, 0, 0, 0, 1, 0, 0, 0,
						 0, 0, 0, 0, 1, 0, 0, 0},

			{0, 0, 1, 1, 1, 1, 0, 0,//8
						 0, 1, 0, 0, 0, 0, 1, 0,
						 0, 1, 0, 0, 0, 0, 1, 0,
						 0, 0, 1, 1, 1, 1, 0, 0,
						 0, 1, 0, 0, 0, 0, 1, 0,
						 0, 1, 0, 0, 0, 0, 1, 0,
						 0, 1, 0, 0, 0, 0, 1, 0,
						 0, 0, 1, 1, 1, 1, 0, 0},

			{0, 0, 1, 1, 1, 1, 0, 0,//9
						 0, 1, 0, 0, 0, 0, 1, 0,
						 0, 1, 0, 0, 0, 0, 1, 0,
						 0, 0, 1, 1, 1, 1, 1, 0,
						 0, 0, 0, 0, 0, 0, 1, 0,
						 0, 0, 0, 0, 0, 0, 1, 0,
						 0, 1, 0, 0, 0, 0, 1, 0,
						 0, 0, 1, 1, 1, 1, 0, 0}
					 };

void TAdaline::Learn(){
  double e;
  do{
    e=0;
    for (int i=0; i<OutputCount; i++){//example number
      for (int j=0; j<OutputCount; j++){//neyron number
	double Tp=(i==j)?1:0;
	double Op=1/(1+exp(-S[j].Calc(Numbers[i])));
	double p=Tp-Op;
	e+=p*p;
	for (int k=0; k<InputCount; k++){//koef number
	  S[j].Koef[k]+=7*(Tp-Op)*Op*(1-Op)*Numbers[i][k];
	};
      };
    };
//    cout<<e<<"\n";
  }while(e>0.001);
};

void TAdaline::Check(double *A){
	int i;
	cout<<"\n";
	for (i=0; i<InputCount; i++) {
		if (A[i]==0) {cout<<"";} else {cout<<"";};
		if (((i+1) % 8) == 0) {cout<<"\n";};
	};
	cout<<" ";
	for (i=0; i<OutputCount; i++){
		double v=2/(1+exp(-S[i].Calc(A)))-1;
		cout<<i<<((v>0)?"!!!":"")<<": "<<v<<" ";
	};
	cout<<"\n";
};

double CheckNum[64]=
		 {0, 0, 1, 1, 1, 1, 0, 0,
			0, 1, 0, 0, 0, 0, 1, 0,
			0, 1, 0, 0, 0, 0, 1, 0,
			0, 0, 1, 1, 1, 1, 0, 0,
			0, 1, 0, 0, 0, 0, 1, 0,
			0, 1, 0, 0, 0, 0, 1, 0,
			0, 1, 0, 0, 0, 0, 1, 0,
			0, 0, 1, 1, 1, 1, 0, 0};

void main(){
	TAdaline *Ad = new TAdaline(10, 64);
	Ad->Learn();
	Ad->Check(CheckNum);
	delete Ad;
};